"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.responseValidationFactory = exports.parseRequestInput = void 0;
function parseRequestInput(schema, input) {
    return schema?.parse(input);
}
exports.parseRequestInput = parseRequestInput;
function responseValidationFactory(possibleResponses, defaultResponse) {
    // Exploit the natural ordering matching the desired specificity of eg: 404 vs 4xx
    possibleResponses.sort((x, y) => x[0] < y[0] ? -1 : 1);
    return (status, value) => {
        for (const [match, schema] of possibleResponses) {
            const isMatch = /^\d+$/.test(match) && String(status) === match ||
                /^\d[xX]{2}$/.test(match) && String(status)[0] === match[0];
            if (isMatch) {
                return schema.parse(value);
            }
        }
        if (defaultResponse) {
            return defaultResponse.parse(value);
        }
        return value;
    };
}
exports.responseValidationFactory = responseValidationFactory;
//# sourceMappingURL=zod.js.map